-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local hasSentMapData = false
local vehicleID = obj:getID()
local Clock = "@scirocco_lcd_tex"
local dist = 0
local fuelOld=1
local timer=0
local distconso = 0

local function runFunc(func)
	obj:queueGameEngineLua("if be:getObjectByID("..vehicleID..") then be:getObjectByID("..vehicleID.."):queueJSUITexture('"..Clock.."', '"..func.."') end")
end

local function onInit()
    --hasSentMapData = false
    obj:queueGameEngineLua("extensions.loadModule('ui/uinavi')")

    obj:queueGameEngineLua('be:getObjectByID('..vehicleID..'):createUITexture("'..Clock..'", "local://local/vehicles/Scirocco_GTII/Clock.html", 103, 34, UI_TEXTURE_USAGE_AUTOMATIC, 30)')
	fuelOld = 1
    --hasSentMapData = true
end

local function onReset()
    --local destroy = 'be:getObjectByID('..vehicleID..'):destroyUITexture("'..YotaDigiClock..'")'
    --obj:queueGameEngineLua(destroy)
    onInit()
end

local function updateGFX(dt)
	timer = timer + dt
	dist = dist + (electrics.values.wheelspeed*dt or 0)
	
	if timer > 1 then
		timer=0
		runFunc( "updateValues(" .. dist ..", ".. (electrics.values.wheelspeed or 0)*3.6 ..", ".. (electrics.values.oiltemp or 0) ..", ".. (electrics.values.watertemp or 0) ..")" )
		runFunc( "updateConso(".. fuelOld ..", ".. (electrics.values.fuel or 0) ..", ".. dist-distconso ..")" )
		fuelOld = (electrics.values.fuel or 0)
		distconso = dist
		electrics.values.hotengine =  (electrics.values.oiltemp or 0)>120 or (electrics.values.watertemp or 0)> 120
	end

end

local function nextInfo()
	runFunc( "nextInfo()")
end

-- public interface
M.onInit    = onInit
M.onReset   = onReset
M.updateGFX = updateGFX
M.nextInfo  = nextInfo

return M
